<HTML>
<HEAD>
<TITLE>AspPDF Encryption Demo</TITLE>

<script language="JavaScript">
function ChangeKeyLength(list)
{
	if(list.value == 40 )
	{
		if( list.form.Print[1].checked )
			list.form.Print[2].checked = true;

		list.form.Print[1].disabled = true;
		list.form.Extract.disabled=true;
		list.form.Assemble.disabled=true;
		list.form.Form.disabled=true;
	}
	else //128
	{
		list.form.Print[1].disabled = false;
		list.form.Extract.disabled=false;
		list.form.Assemble.disabled=false;
		list.form.Form.disabled=false;
	}
}

</script>

</HEAD>
<BODY>

<TABLE WIDTH="600"><TR><TD>
<FONT FACE="Arial" SIZE=2">
<H3>AspPDF Encryption Demo</H3>
AspPDF supports both 40-bit and 128-bit encryption of PDF documents it creates and
reads.
<P>
This demo enables you to create
encrypted PDF documents with various
sets of permission flags. You may optionally specify a user password, owner
password, or both.

<P>
<FORM METHOD="POST" ACTION="demo_encrypt.asp">

<TABLE STYLE="font-name:Arial; font-size: 12" BORDER="0" CELLSPACING="0" CELLPADDING="2">
<TR><TD COLSPAN="2" ALIGN="CENTER">
<TEXTAREA NAME="BigText" COLS="40" ROWS="3"><% if Request("BigText") = "" Then Response.Write "Hello world!" Else Response.Write Server.HtmlEncode(Request("BigText")) %></TEXTAREA>
</TD>
</TR>
<TR>
<TD ALIGN="RIGHT">RC4 Key Length:</TD>
	<TD>
	<SELECT NAME="KeyLength" OnChange="javascript:ChangeKeyLength(this)">
	<OPTION VALUE="40"<% If Request("KeyLength") = "40" Then Response.Write " SELECTED" %>>40-bit
	<OPTION VALUE="128"<% If Request("KeyLength") = "128" or Request("KeyLength") = "" Then Response.Write " SELECTED" %>>128-bit
	</SELECT>
	</TD>
</TR>
<TR>
	<TD ALIGN="RIGHT">User Password:</TD>
	<TD><INPUT TYPE="PASSWORD" NAME="UPWD" VALUE="<% = Server.HtmlEncode(Request("UPWD")) %>"></TD>
</TR>
<TR>
	<TD ALIGN="RIGHT">Owner Password:</TD>
	<TD><INPUT TYPE="PASSWORD" NAME="OPWD" VALUE="<% = Server.HtmlEncode(Request("OPWD")) %>"></TD>
</TR>
<TR><TD ALIGN="RIGHT"><B>Permissions</B></TD><TD>&nbsp;</TD></TR>
<TR>
	<TD ALIGN="RIGHT">Printing:</TD>
	<TD>
		<INPUT TYPE="RADIO" NAME="Print" VALUE="0"<% If Request("Print") = "0" or Request("Print") = "" Then Response.Write " CHECKED" %>> None
		<INPUT TYPE="RADIO" NAME="Print" VALUE="1"<% If Request("Print") = "1" Then Response.Write " CHECKED" %> <% If Request("KeyLength") = "40" Then Response.Write " DISABLED" %>> Lo-Res
		<INPUT TYPE="RADIO" NAME="Print" VALUE="2"<% If Request("Print") = "2" Then Response.Write " CHECKED" %>> Full
	</TD>
</TR>

<TR>
	<TD ALIGN="RIGHT">Changing the document:</TD>
	<TD><INPUT TYPE="CHECKBOX" NAME="Change"<% If Request("Change") = "on" Then Response.Write " CHECKED" %>></TD>
</TR>
<TR>
	<TD ALIGN="RIGHT">Content Copying or Extraction:</TD>
	<TD><INPUT TYPE="CHECKBOX" NAME="Copy"<% If Request("Copy") = "on" Then Response.Write " CHECKED" %>></TD>
</TR>
<TR>
	<TD ALIGN="RIGHT">Authoring Comments and Form Fields:</TD>
	<TD><INPUT TYPE="CHECKBOX" NAME="Author"<% If Request("Author") = "on" Then Response.Write " CHECKED" %>></TD>
</TR>
<TR>
	<TD ALIGN="RIGHT">Form Field Fill-in or Signing:</TD>
	<TD><INPUT TYPE="CHECKBOX" NAME="Form"<% If Request("Form") = "on" Then Response.Write " CHECKED" %><% If Request("KeyLength") = "40" Then Response.Write " DISABLED" %>></TD>
</TR>
<TR>
	<TD ALIGN="RIGHT">Content Accessibility:</TD>
	<TD><INPUT TYPE="CHECKBOX" NAME="Extract"<% If Request("Extract") = "on" Then Response.Write " CHECKED" %><% If Request("KeyLength") = "40" Then Response.Write " DISABLED" %>></TD>
</TR>
<TR>
	<TD ALIGN="RIGHT">Document Assembly:</TD>
	<TD><INPUT TYPE="CHECKBOX" NAME="Assemble"<% If Request("Assemble") = "on" Then Response.Write " CHECKED" %><% If Request("KeyLength") = "40" Then Response.Write " DISABLED" %>></TD>
</TR>
<TR><TD COLSPAN="2"><INPUT TYPE="SUBMIT" NAME="Save" VALUE="Generate PDF"></TD></TR>
</TABLE>

</FORM>

<!--METADATA TYPE="TypeLib" UUID="{414FEE4B-2879-4090-957E-423567FFCFC6}"-->

<%
	If Request("Save") <> "" Then
		Set PDF = Server.CreateObject("Persits.Pdf")
		
		' Create a new document
		Set Doc = PDF.CreateDocument

		' Add a page
		Set Page = Doc.Pages.Add
		
		' Draw text on page
		Page.Canvas.DrawText Request("BigText"), "x=10, y=700", doc.Fonts("Times-Roman")

		' Build permission flags
		Flags = 0

		If Request("KeyLength") = "40" Then
			If Request("Print") = "2" Then Flags = Flags Or pdfPrint
		Else
			If Request("Print") = "2" Then Flags = Flags Or pdfPrint Or pdfPrintHigh
			If Request("Print") = "1" Then Flags = Flags Or pdfPrint
		End If
		
		
		If Request("Change") = "on" Then Flags = Flags Or pdfModify
		If Request("Copy") = "on" Then Flags = Flags Or pdfCopy
		If Request("Author") = "on" Then Flags = Flags Or pdfAnnotations
		If Request("Form") = "on" Then Flags = Flags Or pdfForm
		If Request("Extract") = "on" Then Flags = Flags Or pdfExtract
		If Request("Assemble") = "on" Then Flags = Flags Or pdfAssemble

		' Encrypt document using the specified user/owner passwords

		Doc.Encrypt Request("OPWD"), Request("UPWD"), Request("KeyLength"), Flags

		' We use Session ID for file names
		' false means "do not overwrite"
		' The method returns generated file name
		Path = Server.MapPath( "files") & "\" & Session.SessionID & ".pdf"
		FileName = Doc.Save( Path, false)

		Response.Write "<P><B>Success. Your PDF file <font color=gray>" & FileName & "</font> can be downloaded <A HREF=""files/" & FileName & """><B>here</B></A></B>."
	End If
%>
<P>
<B><A HREF="demo_encrypt.zip">Download source code (ASP and ASP.NET/C#) for this demo</A></B>

</FONT>
</TD></TR></TABLE>

</BODY>
</HTML>